<template>
    <div class="auth-wrapper text-center">
        <main class="form-signin">
            <form @submit="onRegister" class="main-form">
                <img class="mb-4 form-img" src="../assets/images/poke-ball.png" alt="" width="72" height="57">
                <h1 class="h3 mb-3 fw-normal">Be part of an awesome community</h1>

                <div class="form-floating">
                    <input v-model="first_name" type="text" class="form-control" id="fname" required>
                    <label for="floatingInput">First Name</label>
                </div>
                <div class="form-floating">
                    <input v-model="last_name" type="text" class="form-control" id="lname" required>
                    <label for="floatingInput">Last Name</label>
                </div>
                <div class="form-floating">
                    <input v-model="birthdate" type="date" class="form-control" id="bdate" required>
                    <label for="floatingInput">Birthdate</label>
                </div>
                <div class="form-floating">
                    <input v-model="email" type="email" class="form-control" id="email" required>
                    <label for="floatingInput">Email address</label>
                </div>
                <div class="form-floating">
                    <input v-model="password" type="password" class="form-control" id="password" required>
                    <label for="floatingPassword">Password</label>
                </div>
                <div class="form-floating">
                    <input v-model="password_confirmation" type="password" class="form-control"
                        id="password_confirmation" required>
                    <label for="floatingPassword">Password Confirmation</label>
                </div>
                <br>
                <button type="submit" class="mb-2 w-100 btn btn-lg btn-primary btn-form-action">Sign up</button>
            </form>
            <br>
            <p>Already have an account? <a @click="signin" class="text-primary">Click here to sign in</a></p>
           
            <p class="mt-5 mb-3 text-muted">
                Designed and Developed by <a href="https://gabrielarellano.tech/" target="blank">
                    <img src="https://gabrielarellano.tech/wp-content/uploads/2022/12/default-logo.png"
                        class="footer-logo">
                </a>
            </p>
        </main>
    </div>
</template>

<script>
export default {
    name: "RegisterView",
    data() {
        return {
            token: "",
            first_name: "",
            last_name: "",
            birthdate: "",
            email: "",
            password: "",
            password_confirmation: "",
        }
    },
    created(){
        this.token = localStorage.getItem("pokemon-bearer-token");
        if (this.token) {
            this.$router.push('/dashboard') 
        }
    },
    methods: {
        
        async register(credentials) {
            const res = await fetch('http://localhost:8000/api/register', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json',
                },
                body: JSON.stringify(credentials)
            })

            const data = await res.json()
            localStorage.setItem("pokemon-bearer-token", data.token);
            this.$router.push('/dashboard') 
        },
        onRegister(e) {
            e.preventDefault();

            const registerAttempt = {
                first_name: this.first_name,
                last_name: this.last_name,
                birthdate: this.birthdate,
                email: this.email,
                password: this.password,
                password_confirmation: this.password_confirmation,
            }

            if (this.first_name && this.last_name && this.birthdate && this.email && this.password && this.password_confirmation) {
                this.register(registerAttempt)
            }
            else {
                alert('Please suffice all data')
            }
        },
        signin(){
            this.$router.push('/') 
        }
    },
  
}
</script>